import 'package:nui_form/component/nuif_text.dart';

class EFormLayoutRenderer{
  late String _baseUrl;
  late NUIFTextStyle _textStyle;

  static EFormLayoutRenderer? _instance;

  EFormLayoutRenderer._builder(EFormLayoutRendererBuilder builder){
    _baseUrl = builder._baseUrl;
    _textStyle = builder._textStyle;
    _instance = this;
  }

  static EFormLayoutRenderer get instance{
    if(_instance == null) throw Exception("EFormLayoutRenderer: You have not initialized the renderer");
    return _instance!;
  }

  NUIFTextStyle get textStyle{
    return _textStyle;
  }

  String get baseUrl{
    return _baseUrl;
  }
}

class EFormLayoutRendererBuilder{
  String _baseUrl;
  NUIFTextStyle _textStyle;

  EFormLayoutRendererBuilder baseUrl(String baseUrl){
    _baseUrl = baseUrl;
    return this;
  }

  EFormLayoutRendererBuilder textStyle(NUIFTextStyle style){
    _textStyle = style;
    return this;
  }

  EFormLayoutRenderer build(){
    final renderer = EFormLayoutRenderer._builder(this);
    return renderer;
  }
}